﻿using System;
using System.ComponentModel;
using System.Windows;

namespace demo
{
	public class ViewModelBase : INotifyPropertyChanged
	{
		protected bool isDownloaded;

		public ViewModelBase()
		{
		}

		public event PropertyChangedEventHandler PropertyChanged;

		public bool IsDownloaded
		{
			get
			{
				return this.isDownloaded;
			}
			set
			{
				if (this.isDownloaded != value)
				{
					this.isDownloaded = value;
					this.NotifyPropertyChanged("IsDownloaded");
				}
			}
		}
		/// <summary>
		/// spustí se na klientovi v okamžiku, kdy proběhla deserializace. Nyní je možné inicializovat objekt. Náhrada konstruktoru.
		/// </summary>
		public virtual void Init()
		{
		}

		protected void NotifyPropertyChanged(string propertyName)
		{
			PropertyChangedEventHandler handler = this.PropertyChanged;
			if (propertyName != null && handler != null)
			{
				if (Deployment.Current.Dispatcher.CheckAccess())
				{
					handler(this, new PropertyChangedEventArgs(propertyName)); 
				}
				else
				{
					Deployment.Current.Dispatcher.BeginInvoke(() =>
					{
						handler(this, new PropertyChangedEventArgs(propertyName));
					});
				}
			}
		}
	}
}